From a4f12da4541f308198061f3e046c3f3e872f79c4 Mon Sep 17 00:00:00 2001
From: Michael Hanselmann <hansmi@google.com>
Date: Wed, 10 Feb 2010 11:35:19 +0100
Subject: [PATCH] Check built manpages for errors
MIME-Version: 1.0
Content-Type: text/plain; charset=UTF-8
Content-Transfer-Encoding: 8bit

One fix is necessary in gnt-cluster.sgml. Also adding β€œDELETE_ON_ERROR”
target to remove output file if an error occurred while building it (in
this case the manpage).

This was reported by Iustin Pop in issue 87 and proposed check method
taken from Lintian.
http://code.google.com/p/ganeti/issues/detail?id=87

Signed-off-by: Michael Hanselmann <hansmi@google.com>
Reviewed-by: Iustin Pop <iustin@google.com>
---
 Makefile.am          |  7 +++++++
 autotools/check-man  | 24 ++++++++++++++++++++++++
 man/gnt-cluster.sgml |  4 ++--
 3 files changed, 33 insertions(+), 2 deletions(-)
 create mode 100755 autotools/check-man

diff --git a/Makefile.am b/Makefile.am
index f4d348c40..feb2dc517 100644
--- a/Makefile.am
+++ b/Makefile.am
@@ -14,6 +14,7 @@ DOCBOOK_WRAPPER = $(top_srcdir)/autotools/docbook-wrapper
 BUILD_BASH_COMPLETION = $(top_srcdir)/autotools/build-bash-completion
 RUN_IN_TEMPDIR = $(top_srcdir)/autotools/run-in-tempdir
 CHECK_PYTHON_CODE = $(top_srcdir)/autotools/check-python-code
+CHECK_MAN = $(top_srcdir)/autotools/check-man
 REPLACE_VARS_SED = autotools/replace_vars.sed
 
 hypervisordir = $(pkgpythondir)/hypervisor
@@ -23,6 +24,9 @@ rapidir = $(pkgpythondir)/rapi
 toolsdir = $(pkglibdir)/tools
 docdir = $(datadir)/doc/$(PACKAGE)
 
+# Delete output file if an error occurred while building it
+.DELETE_ON_ERROR:
+
 DIRS = \
 	autotools \
 	daemons \
@@ -239,6 +243,7 @@ EXTRA_DIST = \
 	pylintrc \
 	autotools/build-bash-completion \
 	autotools/check-python-code \
+	autotools/check-man \
 	autotools/docbook-wrapper \
 	$(RUN_IN_TEMPDIR) \
 	daemons/daemon-util.in \
@@ -399,9 +404,11 @@ man/%.html.in: man/%.sgml man/footer.sgml $(DOCBOOK_WRAPPER)
 
 man/%.7: man/%.7.in $(REPLACE_VARS_SED)
 	sed -f $(REPLACE_VARS_SED) < $< > $@
+	$(CHECK_MAN) $@
 
 man/%.8: man/%.8.in $(REPLACE_VARS_SED)
 	sed -f $(REPLACE_VARS_SED) < $< > $@
+	$(CHECK_MAN) $@
 
 man/%.html: man/%.html.in $(REPLACE_VARS_SED)
 	sed -f $(REPLACE_VARS_SED) < $< > $@
diff --git a/autotools/check-man b/autotools/check-man
new file mode 100755
index 000000000..5c0e25780
--- /dev/null
+++ b/autotools/check-man
@@ -0,0 +1,24 @@
+#!/bin/bash
+#
+
+# Copyright (C) 2010 Google Inc.
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful, but
+# WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+# General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
+# 02110-1301, USA.
+
+set -e
+
+! LC_ALL=C MANWIDTH=80 \
+man --warnings --encoding=utf8 --local-file "$1" 2>&1 >/dev/null | grep .
diff --git a/man/gnt-cluster.sgml b/man/gnt-cluster.sgml
index 5c33c7e5c..4b3b8223f 100644
--- a/man/gnt-cluster.sgml
+++ b/man/gnt-cluster.sgml
@@ -723,8 +723,8 @@
       <para>
         Note that only active disks can be checked by this command; in
         case a disk cannot be activated it's advised to use
-        <command>gnt-instance activate-disks --ignore-size
-        ...</command> to force activation without regard to the
+        <command>gnt-instance activate-disks --ignore-size ...</command> to
+        force activation without regard to the
         current size.
       </para>
 
-- 
GitLab